/***************************************************************************
 *
 * Copyright (c) 1999 BalaBit Computing
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Inspired by nsyslog, originally written by Darren Reed.
 *
 * $Id: log.h,v 1.5 1999/04/08 17:50:29 bazsi Exp $
 *
 ***************************************************************************/

#ifndef __LOG_H
#define __LOG_H

#include "syslog-ng.h"
#include "io.h"

#include <sys/time.h>

#define CLASS_DECLARE
#include "log.h.x"
#undef CLASS_DECLARE

/* CLASS:
    (class
      (name log_info)
      (vars
        (recvd simple time_t)
        (source object log_handler)
        (pri simple int)
        
        ; message parts
        (msg string)
        (date string)
        (program string)
        (host string)))
*/

/* CLASS:
     (class
       (name log_handler)
       (vars
         (handler method void "struct log_info *")
         (init method int)
	 (reinit method int)
	 (destroy method int)))
*/

#define HANDLE_LOG(l, i) (((struct log_handler *) l)->handler((struct log_handler *) (l), i))
#define LOG_HANDLER_INIT(l) ((struct log_handler *) l)->init((struct log_handler *) (l))
#define LOG_HANDLER_REINIT(l) ((struct log_handler *) l)->reinit((struct log_handler *) (l))
#define LOG_HANDLER_DESTROY(l) ((struct log_handler *) l)->destror((struct log_handler *) (l))

struct log_info *make_log_info(struct ol_string *msg);

/* CLASS:
     (class
       (name log_handler_pipe)
       (super log_handler)
       (vars
         (next object log_handler)))
*/

#define append_log_handler(item, append) ((struct log_handler_pipe *) (item))->next = ((struct log_handler *) append);

#endif

